<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';

import { CONTENT_TYPES } from '../../common/content-types';
import {
  SupportCopy,
  SupportHero,
  SupportNote,
  SupportCopyMarkdown,
} from '~/components/support/index.vue';
import { getPageMetadata } from '~/common/meta';

import { getClient } from '~/plugins/contentful.js';
import { supportDataHelper } from '~/services/support/support.service';

export default Vue.extend({
  components: {
    SupportCopy,
    SupportHero,
    SupportNote,
    SupportCopyMarkdown,
  },
  nuxtI18n: false,
  async asyncData({ error }) {
    try {
      const entry = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 5,
        'sys.id': '2GPPvNCbnudkDR2bPqA2Oy',
      });
      const { pageContent } = entry.items[0].fields;
      const seoMetadata = entry.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const support = supportDataHelper(pageContent);
      return { support, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>

<template>
  <SlpContainer>
    <SupportHero :data="support.supportHero" />
    <SlpSideNavigation :data="support.side_menu">
      <template #footer>
        <div>
          <SlpTypography
            v-show="support.side_menu.hyperlinks.text"
            tag="div"
            variant="body3-bold"
            class="nav-heading"
            >{{ support.side_menu.hyperlinks.text }}</SlpTypography
          >
          <SlpButton
            v-for="(button, buttonIndex) in support.side_menu.hyperlinks.data"
            :key="buttonIndex"
            class="hyperlinks"
            :variant="button.variant"
            :href="button.href"
            :data-ga-name="button.data_ga_name"
            :data-ga-location="button.data_ga_location"
            >{{ button.text }}
            <SlpIcon
              v-if="button.icon"
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
      </template>
      <component
        :is="component.name"
        v-for="(component, index) in support.components"
        :key="component.name + index"
        :data="component"
        :index="index"
      />
    </SlpSideNavigation>
  </SlpContainer>
</template>
<style lang="scss" scoped>
* {
  font-display: swap;
}
.hyperlinks {
  font-size: $font-size-default;
  line-height: 20px;
  font-weight: $font-weight-normal;
  text-align: left !important;
}
.nav-heading {
  margin-bottom: $spacing-8;
}
</style>
